/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: SAPIEngine.hpp 14 2011-05-09 04:08:06Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _SPEECH_CONTROLLER_FRAMEWORK_SAPI_SAPI_ENGINE_HPP_
#define _SPEECH_CONTROLLER_FRAMEWORK_SAPI_SAPI_ENGINE_HPP_

#include "spcf/core/Engine.hpp"

namespace spcf {

	class SAPIEngine_i;

	class SAPIEngine : public Engine {
	private:
		SAPIEngine_i* impl;

	public:
		SAPIEngine();
		virtual ~SAPIEngine();

	public:
		void init();
		void start();
		void stop();
		void destroy();

	public:
		void addGrammar(const GrammarPtr& grammar);
		GrammarPtr getGrammar(const std::string& name);
		GrammarPtr removeGrammar(const std::string& name);
		void clearGrammar();
	};

}  // namespace spcf

#endif
